## sundials 4.1.0+dfsg

=== CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer: Radu Serban, David J. Gardner, Cody J. Balos,
#             and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# ---------------------------------------------------------------
# Initial commands
# ---------------------------------------------------------------

# Require a fairly recent cmake version
cmake_minimum_required(VERSION 3.1.3)

# Libraries linked via full path no longer produce linker search paths
# Allows examples to build
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# MACOSX_RPATH is enabled by default
# Fixes dynamic loading on OSX
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # Added in CMake 3.0
else()
  if(APPLE)
    set(CMAKE_MACOSX_RPATH 1)
  endif()
endif()

# Project SUNDIALS (initially only C supported)
# sets PROJECT_SOURCE_DIR and PROJECT_BINARY_DIR variables
PROJECT(sundials C)

# Set some variables with info on the SUNDIALS project
SET(PACKAGE_BUGREPORT "woodward6@llnl.gov")
SET(PACKAGE_NAME "SUNDIALS")
SET(PACKAGE_STRING "SUNDIALS 4.1.0")
SET(PACKAGE_TARNAME "sundials")

# set SUNDIALS version numbers
# (use "" for the version label if none is needed)
SET(PACKAGE_VERSION_MAJOR "4")
SET(PACKAGE_VERSION_MINOR "1")
SET(PACKAGE_VERSION_PATCH "0")
SET(PACKAGE_VERSION_LABEL "")

IF(PACKAGE_VERSION_LABEL)
  SET(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}-${PACKAGE_VERSION_LABEL}")
ELSE()
  SET(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
ENDIF()

SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

# Prohibit in-source build
IF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  MESSAGE(FATAL_ERROR "In-source build prohibited.")
ENDIF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Hide some cache variables
MARK_AS_ADVANCED(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)

# Always show the C compiler and flags
MARK_AS_ADVANCED(CLEAR
  CMAKE_C_COMPILER
  CMAKE_C_FLAGS)

# Specify the VERSION and SOVERSION for shared libraries

SET(arkodelib_VERSION "3.1.0")
SET(arkodelib_SOVERSION "3")

SET(cvodelib_VERSION "4.1.0")
SET(cvodelib_SOVERSION "4")

SET(cvodeslib_VERSION "4.1.0")
SET(cvodeslib_SOVERSION "4")

SET(idalib_VERSION "4.1.0")
SET(idalib_SOVERSION "4")

SET(idaslib_VERSION "3.1.0")
SET(idaslib_SOVERSION "3")

SET(kinsollib_VERSION "4.1.0")
SET(kinsollib_SOVERSION "4")

SET(cpodeslib_VERSION "0.0.0")
SET(cpodeslib_SOVERSION "0")

SET(nveclib_VERSION "4.1.0")
SET(nveclib_SOVERSION "4")

SET(sunmatrixlib_VERSION "2.1.0")
SET(sunmatrixlib_SOVERSION "2")

SET(sunlinsollib_VERSION "2.1.0")
SET(sunlinsollib_SOVERSION "2")

SET(sunnonlinsollib_VERSION "1.1.0")
SET(sunnonlinsollib_SOVERSION "1")

# Specify the location of additional CMAKE modules
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/config)

# Get correct build paths automatically, but expose CMAKE_INSTALL_LIBDIR
# as a regular cache variable so that a user can more easily see what
# the library dir was set to be by GNUInstallDirs.
INCLUDE(GNUInstallDirs)
MARK_AS_ADVANCED(CLEAR CMAKE_INSTALL_LIBDIR)

# ---------------------------------------------------------------
# Which modules to build?
# ---------------------------------------------------------------

# For each SUNDIALS solver available (i.e. for which we have the
# sources), give the user the option of enabling/disabling it.

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/arkode")
  OPTION(BUILD_ARKODE "Build the ARKODE library" ON)
ELSE()
  SET(BUILD_ARKODE OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvode")
  OPTION(BUILD_CVODE "Build the CVODE library" ON)
ELSE()
  SET(BUILD_CVODE OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cvodes")
  OPTION(BUILD_CVODES "Build the CVODES library" ON)
ELSE()
  SET(BUILD_CVODES OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/ida")
  OPTION(BUILD_IDA "Build the IDA library" ON)
ELSE()
  SET(BUILD_IDA OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/idas")
  OPTION(BUILD_IDAS "Build the IDAS library" ON)
ELSE()
  SET(BUILD_IDAS OFF)
ENDIF()

IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/kinsol")
  OPTION(BUILD_KINSOL "Build the KINSOL library" ON)
ELSE()
  SET(BUILD_KINSOL OFF)
ENDIF()

# CPODES is always OFF for now.  (commented out for Release); ToDo: better way to do this?
#IF(IS_DIRECTORY "${sundials_SOURCE_DIR}/src/cpodes")
#  OPTION(BUILD_CPODES  "Build the CPODES library"  OFF)
#ELSE()
#  SET(BUILD_CPODES OFF)
#ENDIF()

# ---------------------------------------------------------------
# MACRO definitions
# ---------------------------------------------------------------
INCLUDE(CMakeParseArguments) # can be removed when CMake 3.5+ is required
INCLUDE(SundialsCMakeMacros)
INCLUDE(SundialsAddF2003InterfaceLibrary)
INCLUDE(SundialsAddTest)
INCLUDE(SundialsAddTestInstall)

# ---------------------------------------------------------------
# Check for deprecated SUNDIALS CMake options/variables
# ---------------------------------------------------------------
INCLUDE(SundialsDeprecated)

# ---------------------------------------------------------------
# xSDK specific options
# ---------------------------------------------------------------
INCLUDE(SundialsXSDK)

# ---------------------------------------------------------------
# Build specific C flags
# ---------------------------------------------------------------

# Hide all build type specific flags
MARK_AS_ADVANCED(FORCE
  CMAKE_C_FLAGS_DEBUG
  CMAKE_C_FLAGS_MINSIZEREL
  CMAKE_C_FLAGS_RELEASE
  CMAKE_C_FLAGS_RELWITHDEBINFO)

# Only show flags for the current build type if it is set
# NOTE: Build specific flags are appended those in CMAKE_C_FLAGS
IF(CMAKE_BUILD_TYPE)
  IF(CMAKE_BUILD_TYPE MATCHES "Debug")
    MESSAGE("Appending C debug flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_DEBUG)
  ELSEIF(CMAKE_BUILD_TYPE MATCHES "MinSizeRel")
    MESSAGE("Appending C min size release flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_MINSIZEREL)
  ELSEIF(CMAKE_BUILD_TYPE MATCHES "Release")
    MESSAGE("Appending C release flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_RELEASE)
  ELSEIF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    MESSAGE("Appending C release with debug info flags")
    MARK_AS_ADVANCED(CLEAR CMAKE_C_FLAGS_RELWITHDEBINFO)
  ENDIF()
ENDIF()

# ---------------------------------------------------------------
# Option to specify precision (realtype)
# ---------------------------------------------------------------

SET(DOCSTR "single, double, or extended")
SHOW_VARIABLE(SUNDIALS_PRECISION STRING "${DOCSTR}" "double")

# prepare substitution variable PRECISION_LEVEL for sundials_config.h
STRING(TOUPPER ${SUNDIALS_PRECISION} SUNDIALS_PRECISION)
SET(PRECISION_LEVEL "#define SUNDIALS_${SUNDIALS_PRECISION}_PRECISION 1")

# prepare substitution variable FPRECISION_LEVEL for sundials_fconfig.h
IF(SUNDIALS_PRECISION MATCHES "SINGLE")
  SET(FPRECISION_LEVEL "4")
ENDIF(SUNDIALS_PRECISION MATCHES "SINGLE")
IF(SUNDIALS_PRECISION MATCHES "DOUBLE")
  SET(FPRECISION_LEVEL "8")
ENDIF(SUNDIALS_PRECISION MATCHES "DOUBLE")
IF(SUNDIALS_PRECISION MATCHES "EXTENDED")
  SET(FPRECISION_LEVEL "16")
ENDIF(SUNDIALS_PRECISION MATCHES "EXTENDED")

# ---------------------------------------------------------------
# Option to specify index type
# ---------------------------------------------------------------

SET(DOCSTR "Signed 64-bit (64) or signed 32-bit (32) integer")
SHOW_VARIABLE(SUNDIALS_INDEX_SIZE STRING "${DOCSTR}" "64")
SET(DOCSTR "Integer type to use for indices in SUNDIALS")
SHOW_VARIABLE(SUNDIALS_INDEX_TYPE STRING "${DOCSTR}" "")
MARK_AS_ADVANCED(SUNDIALS_INDEX_TYPE)
include(SundialsIndexSize)

# ---------------------------------------------------------------
# Enable Fortran interface?
# ---------------------------------------------------------------

# Fortran interface is disabled by default
SET(DOCSTR "Enable Fortran 77 interfaces")
OPTION(F77_INTERFACE_ENABLE "${DOCSTR}" OFF)

# Check that at least one solver with a Fortran 77 interface is built
IF(NOT BUILD_ARKODE AND NOT BUILD_CVODE AND NOT BUILD_IDA AND NOT BUILD_KINSOL)
  IF(F77_INTERFACE_ENABLE)
    PRINT_WARNING("Enabled packages do not support Fortran 77 interface" "Disabling F77 interface")
    FORCE_VARIABLE(F77_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  ENDIF()
  HIDE_VARIABLE(F77_INTERFACE_ENABLE)
ENDIF()

# Fortran 2003 interface is disabled by default
SET(DOCSTR "Enable Fortran 2003 interfaces")
OPTION(F2003_INTERFACE_ENABLE "${DOCSTR}" OFF)

# Check that at least one solver with a Fortran 2003 interface is built
IF(NOT BUILD_CVODE)
  IF(F2003_INTERFACE_ENABLE)
    PRINT_WARNING("Enabled packages do not support Fortran 2003 interface" "Disabling F2003 interface")
    FORCE_VARIABLE(F2003_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  ENDIF()
  HIDE_VARIABLE(F2003_INTERFACE_ENABLE)
ENDIF()

IF(F2003_INTERFACE_ENABLE)
  # F2003 interface only supports double precision
  IF(NOT (SUNDIALS_PRECISION MATCHES "DOUBLE"))
    PRINT_WARNING("F2003 interface is not compatible with ${SUNDIALS_PRECISION} precision"
                  "Disabling F2003 interface")
    FORCE_VARIABLE(F2003_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  ENDIF()

  # F2003 interface only supports 64-bit indices
  IF(NOT (SUNDIALS_INDEX_SIZE MATCHES "64"))
    PRINT_WARNING("F2003 interface is not compatible with ${SUNDIALS_INDEX_SIZE}-bit indicies"
                  "Disabling F2003 interface")
    FORCE_VARIABLE(F2003_INTERFACE_ENABLE BOOL "${DOCSTR}" OFF)
  ENDIF()

  # Put all F2003 modules into one build directory
  SET(CMAKE_Fortran_MODULE_DIRECTORY "${CMAKE_BINARY_DIR}/fortran")

  # Allow a user to set where the Fortran modules will be installed
  SET(DOCSTR "Directory where Fortran module files are installed")
  SHOW_VARIABLE(Fortran_INSTALL_MODDIR DIRECTORY "${DOCSTR}" "fortran")
ENDIF()

# ---------------------------------------------------------------
# Options to build static and/or shared libraries
# ---------------------------------------------------------------

OPTION(BUILD_STATIC_LIBS "Build static libraries" ON)
OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Prepare substitution variable SUNDIALS_EXPORT for sundials_config.h
# When building shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllexport)
# When linking to shared SUNDIALS libraries under Windows, use
#      #define SUNDIALS_EXPORT __declspec(dllimport)
# In all other cases (other platforms or static libraries
# under Windows), the SUNDIALS_EXPORT macro is empty

IF(BUILD_SHARED_LIBS AND WIN32)
  SET(SUNDIALS_EXPORT
    "#ifdef BUILD_SUNDIALS_LIBRARY
#define SUNDIALS_EXPORT __declspec(dllexport)
#else
#define SUNDIALS_EXPORT __declspec(dllimport)
#endif")
ELSE(BUILD_SHARED_LIBS AND WIN32)
  SET(SUNDIALS_EXPORT "#define SUNDIALS_EXPORT")
ENDIF(BUILD_SHARED_LIBS AND WIN32)

# Make sure we build at least one type of libraries
IF(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
  PRINT_WARNING("Both static and shared library generation were disabled"
                "Building static libraries was re-enabled")
  FORCE_VARIABLE(BUILD_STATIC_LIBS BOOL "Build static libraries" ON)
ENDIF(NOT BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)

# ---------------------------------------------------------------
# Option to use the generic math libraries (UNIX only)
# ---------------------------------------------------------------

IF(UNIX)

=== examples/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# The examples will be linked with the library corresponding to the build type.
# Whenever building shared libraries, use them to link the examples.
IF(BUILD_SHARED_LIBS)
  SET(LINK_LIBRARY_TYPE "shared")
ELSE()
  SET(LINK_LIBRARY_TYPE "static")
ENDIF()

# Set variables used in generating CMake and Makefiles for examples
IF(EXAMPLES_INSTALL)

  SET(SHELL "sh")
  SET(prefix "${CMAKE_INSTALL_PREFIX}")
  SET(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  SET(includedir "${prefix}/include")
  SET(libdir "${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
  SET(CPP "${CMAKE_C_COMPILER}")
  SET(CPPFLAGS "${CMAKE_C_FLAGS_RELEASE}")
  SET(CC "${CMAKE_C_COMPILER}")
  SET(CFLAGS "${CMAKE_C_FLAGS_RELEASE}")
  SET(LDFLAGS "${CMAKE_EXE_LINKER_FLAGS_RELEASE}")
  LIST2STRING(EXTRA_LINK_LIBS LIBS)

  IF(CXX_FOUND)
    SET(CXX "${CMAKE_CXX_COMPILER}")
    SET(CXX_LNKR "${CMAKE_CXX_COMPILER}")
    SET(CXXFLAGS "${CMAKE_CXX_FLAGS_RELEASE}")
    SET(CXX_LDFLAGS "${CMAKE_CXX_FLAGS_RELEASE}")
    LIST2STRING(EXTRA_LINK_LIBS CXX_LIBS)
  ENDIF(CXX_FOUND)

  IF(F77_FOUND)
    SET(F77 "${CMAKE_Fortran_COMPILER}")
    SET(F77_LNKR "${CMAKE_Fortran_COMPILER}")
    SET(FFLAGS "${CMAKE_Fortran_FLAGS_RELEASE}")
    SET(F77_LDFLAGS "${CMAKE_Fortran_FLAGS_RELEASE}")
    LIST2STRING(EXTRA_LINK_LIBS F77_LIBS)
  ENDIF(F77_FOUND)

  IF(F90_FOUND)
    SET(F90 "${CMAKE_Fortran_COMPILER}")
    SET(F90_LNKR "${CMAKE_Fortran_COMPILER}")
    SET(F90FLAGS "${CMAKE_Fortran_FLAGS_RELEASE}")
    SET(F90_LDFLAGS "${CMAKE_Fortran_FLAGS_RELEASE}")
    LIST2STRING(EXTRA_LINK_LIBS F90_LIBS)
  ENDIF(F90_FOUND)

  IF(SUPERLUMT_FOUND)
    LIST2STRING(SUPERLUMT_LIBRARIES SUPERLUMT_LIBS)
    SET(SUPERLUMT_LIBS "${SUPERLUMT_LINKER_FLAGS} ${SUPERLUMT_LIBS}")
  ENDIF(SUPERLUMT_FOUND)

  IF(KLU_FOUND)
    LIST2STRING(KLU_LIBRARIES KLU_LIBS)
    SET(KLU_LIBS "${KLU_LINKER_FLAGS} ${KLU_LIBS}")
  ENDIF(KLU_FOUND)

  IF(BLAS_FOUND)
    LIST2STRING(BLAS_LIBRARIES BLAS_LIBS)
  ENDIF(BLAS_FOUND)

  IF(LAPACK_FOUND)
    LIST2STRING(LAPACK_LIBRARIES LAPACK_LIBS)
  ENDIF(LAPACK_FOUND)

  IF(MPI_C_FOUND)
    IF(MPI_C_COMPILER)
      SET(MPICC "${MPI_C_COMPILER}")
      SET(MPI_INC_DIR ".")
      SET(MPI_LIB_DIR ".")
      SET(MPI_LIBS "")
      SET(MPI_FLAGS "")
    ELSE()
      SET(MPICC "${CMAKE_C_COMPILER}")
      SET(MPI_INC_DIR "${MPI_INCLUDE_PATH}")
      SET(MPI_LIB_DIR ".")
      LIST2STRING(MPI_LIBRARIES MPI_LIBS)
    ENDIF()
    SET(HYPRE_INC_DIR "${HYPRE_INCLUDE_DIR}")
    SET(HYPRE_LIB_DIR "${HYPRE_LIBRARY_DIR}")
    SET(HYPRE_LIBS "${HYPRE_LIBRARIES}")
  ENDIF()

  IF(MPI_CXX_FOUND)
    IF(MPI_CXX_COMPILER)
      SET(MPICXX "${MPI_CXX_COMPILER}")
    ELSE()
      SET(MPICXX "${CMAKE_CXX_COMPILER}")
      LIST2STRING(MPI_LIBRARIES MPI_LIBS)
    ENDIF()
  ENDIF()

  IF(MPI_Fortran_FOUND)
    IF(MPI_Fortran_COMPILER)
      SET(MPIF77 "${MPI_Fortran_COMPILER}")
      SET(MPIF77_LNKR "${MPI_Fortran_COMPILER}")

      SET(MPIF90 "${MPI_Fortran_COMPILER}")
      SET(MPIF90_LNKR "${MPI_Fortran_COMPILER}")
    ELSE()
      SET(MPIF77 "${CMAKE_Fortran_COMPILER}")
      SET(MPIF77_LNKR "${CMAKE_Fortran_COMPILER}")
      SET(MPI_INC_DIR "${MPI_INCLUDE_PATH}")
      SET(MPI_LIB_DIR ".")
      LIST2STRING(MPI_LIBRARIES MPI_LIBS)

      SET(MPIF90 "${CMAKE_Fortran_COMPILER}")
      SET(MPIF90_LNKR "${CMAKE_Fortran_COMPILER}")
      LIST2STRING(MPI_LIBRARIES MPI_LIBS)
    ENDIF()
  ENDIF()

ENDIF(EXAMPLES_INSTALL)


#----------------------------------------
# Add specific examples
#----------------------------------------

# Add ARKode examples
IF(BUILD_ARKODE)
  ADD_SUBDIRECTORY(arkode)
ENDIF(BUILD_ARKODE)

# Add CVODE examples
IF(BUILD_CVODE)
  ADD_SUBDIRECTORY(cvode)
ENDIF(BUILD_CVODE)

# Add CVODES Examples
IF(BUILD_CVODES)
  ADD_SUBDIRECTORY(cvodes)
ENDIF(BUILD_CVODES)

# Add IDA examples
IF(BUILD_IDA)
  ADD_SUBDIRECTORY(ida)
ENDIF(BUILD_IDA)

# Add IDAS examples
IF(BUILD_IDAS)
  ADD_SUBDIRECTORY(idas)
ENDIF(BUILD_IDAS)

# Add KINSOL examples
IF(BUILD_KINSOL)
  ADD_SUBDIRECTORY(kinsol)
ENDIF(BUILD_KINSOL)

# Add CPODES examples
IF(BUILD_CPODES)
  ADD_SUBDIRECTORY(cpodes)
ENDIF(BUILD_CPODES)

# Add the nvector examples
ADD_SUBDIRECTORY(nvector)

# Add the sunmatrix examples
ADD_SUBDIRECTORY(sunmatrix)

# Add the sunlinearsolver examples
ADD_SUBDIRECTORY(sunlinsol)

# Add the sunnonlinearsolver examples
ADD_SUBDIRECTORY(sunnonlinsol)

=== src/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner, Slaven Peles, and Cody Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# src level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# Add all of the shared SUNDIALS components
ADD_SUBDIRECTORY(sundials)
ADD_SUBDIRECTORY(nvector)
ADD_SUBDIRECTORY(sunmatrix)
ADD_SUBDIRECTORY(sunlinsol)
ADD_SUBDIRECTORY(sunnonlinsol)

# ARKODE library
IF(BUILD_ARKODE)
  ADD_SUBDIRECTORY(arkode)
  IF(F77_INTERFACE_ENABLE AND F77_FOUND)
    ADD_SUBDIRECTORY(arkode/fcmix)
  ENDIF(F77_INTERFACE_ENABLE AND F77_FOUND)
ENDIF(BUILD_ARKODE)

# CVODE library
IF(BUILD_CVODE)
  ADD_SUBDIRECTORY(cvode)
  IF(F77_INTERFACE_ENABLE AND F77_FOUND)
    ADD_SUBDIRECTORY(cvode/fcmix)
  ENDIF(F77_INTERFACE_ENABLE AND F77_FOUND)
ENDIF(BUILD_CVODE)

# CVODES library
IF(BUILD_CVODES)
  ADD_SUBDIRECTORY(cvodes)
ENDIF(BUILD_CVODES)

# IDA library
IF(BUILD_IDA)
  ADD_SUBDIRECTORY(ida)
  IF(F77_INTERFACE_ENABLE AND F77_FOUND)
    ADD_SUBDIRECTORY(ida/fcmix)
  ENDIF(F77_INTERFACE_ENABLE AND F77_FOUND)
ENDIF(BUILD_IDA)

# IDAS library
IF(BUILD_IDAS)
  ADD_SUBDIRECTORY(idas)
ENDIF(BUILD_IDAS)

# KINSOL library
IF(BUILD_KINSOL)
  ADD_SUBDIRECTORY(kinsol)
  IF(F77_INTERFACE_ENABLE AND F77_FOUND)
    ADD_SUBDIRECTORY(kinsol/fcmix)
  ENDIF(F77_INTERFACE_ENABLE AND F77_FOUND)
ENDIF(BUILD_KINSOL)

# CPODES library
IF(BUILD_CPODES)
  ADD_SUBDIRECTORY(cpodes)
ENDIF(BUILD_CPODES)

=== examples/arkode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/arkode level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# C examples
IF(EXAMPLES_ENABLE_C)
  ADD_SUBDIRECTORY(C_serial)
  IF(OPENMP_ENABLE AND OPENMP_FOUND)
    ADD_SUBDIRECTORY(C_openmp)
  ENDIF()
  IF(OPENMP_DEVICE_ENABLE AND OPENMP_FOUND AND OPENMP_SUPPORTS_DEVICE_OFFLOADING)
    ADD_SUBDIRECTORY(C_openmpdev)
  ENDIF()
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(C_parallel)
  ENDIF()
  IF(HYPRE_ENABLE AND HYPRE_FOUND)
    ADD_SUBDIRECTORY(C_parhyp)
  ENDIF()
ENDIF()

# C++ examples
IF(EXAMPLES_ENABLE_CXX AND CXX_FOUND)
  ADD_SUBDIRECTORY(CXX_serial)
  IF(MPI_ENABLE AND MPI_CXX_FOUND)
    ADD_SUBDIRECTORY(CXX_parallel)
  ENDIF()
  IF(MPI_ENABLE AND MPI_CXX_FOUND AND HYPRE_ENABLE AND HYPRE_FOUND)
    ADD_SUBDIRECTORY(CXX_parhyp)
  ENDIF()
ENDIF()

# F77 examples
IF(F77_INTERFACE_ENABLE AND EXAMPLES_ENABLE_F77 AND F77_FOUND)
  ADD_SUBDIRECTORY(F77_serial)
  IF(MPI_ENABLE AND MPI_Fortran_FOUND)
    ADD_SUBDIRECTORY(F77_parallel)
  ENDIF()
ENDIF()

# F90 examples
IF(F77_INTERFACE_ENABLE AND EXAMPLES_ENABLE_F90 AND F90_FOUND)
  ADD_SUBDIRECTORY(F90_serial)
  IF(MPI_ENABLE AND MPI_Fortran_FOUND)
    # currently the only F90_parallel example
    # does not support anything but double precision
    IF(SUNDIALS_PRECISION MATCHES "DOUBLE")
      ADD_SUBDIRECTORY(F90_parallel)
    ENDIF()
  ENDIF()
ENDIF()

=== examples/cvode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David Gardner, Slaven Peles, and
#                Shelby Lockhart @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/cvode level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(serial)
  if(OPENMP_ENABLE AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
  if(OPENMP_DEVICE_ENABLE AND OPENMP_FOUND AND OPENMP_SUPPORTS_DEVICE_OFFLOADING)
    add_subdirectory(C_openmpdev)
  endif()
  if(MPI_ENABLE AND MPI_C_FOUND)
    add_subdirectory(parallel)
  endif()
  if(HYPRE_ENABLE AND HYPRE_FOUND)
    add_subdirectory(parhyp)
  endif()
endif()

# Fortran examples
if(F77_INTERFACE_ENABLE AND EXAMPLES_ENABLE_F77 AND F77_FOUND)
  add_subdirectory(fcmix_serial)
  if(MPI_ENABLE AND MPI_Fortran_FOUND)
    add_subdirectory(fcmix_parallel)
  endif()
endif()

if(F2003_INTERFACE_ENABLE AND EXAMPLES_ENABLE_F90 AND F90_FOUND)
  add_subdirectory(F90_serial)
endif()

# cuda examples
if(EXAMPLES_ENABLE_CUDA)

  if(CUDA_ENABLE AND CUDA_FOUND)
    add_subdirectory(cuda)
  endif()

  if(RAJA_ENABLE AND RAJA_FOUND)
    add_subdirectory(raja)
  endif()

endif(EXAMPLES_ENABLE_CUDA)

=== examples/cvodes/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/cvodes level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# C examples
IF(EXAMPLES_ENABLE_C)
  ADD_SUBDIRECTORY(serial)
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(parallel)
  ENDIF()
  IF(OPENMP_ENABLE AND OPENMP_FOUND)
    ADD_SUBDIRECTORY(C_openmp)
  ENDIF()
ENDIF()

=== examples/ida/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner, Slaven Peles, and Cody Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/ida level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# C examples
IF(EXAMPLES_ENABLE_C)
  ADD_SUBDIRECTORY(serial)
  IF(OPENMP_ENABLE AND OPENMP_FOUND)
    ADD_SUBDIRECTORY(C_openmp)
  ENDIF()
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(parallel)
  ENDIF()
  IF(PETSC_ENABLE AND PETSC_FOUND)
    ADD_SUBDIRECTORY(petsc)
  ENDIF()
ENDIF()

# C++ examples
if(EXAMPLES_ENABLE_CXX)
  if(Trilinos_ENABLE AND Trilinos_FUNCTIONAL)
    add_subdirectory(trilinos)
  endif()
endif()

# Fortran examples
IF(F77_INTERFACE_ENABLE AND EXAMPLES_ENABLE_F77 AND F77_FOUND)
  ADD_SUBDIRECTORY(fcmix_serial)
  IF(OPENMP_ENABLE AND OPENMP_FOUND)
    ADD_SUBDIRECTORY(fcmix_openmp)
  ENDIF()
  IF(PTHREADS_ENABLE AND PTHREADS_FOUND)
    ADD_SUBDIRECTORY(fcmix_pthreads)
  ENDIF()
  IF(MPI_ENABLE AND MPI_Fortran_FOUND)
    ADD_SUBDIRECTORY(fcmix_parallel)
  ENDIF()
ENDIF()

# cuda examples
if(EXAMPLES_ENABLE_CUDA)

  if(CUDA_ENABLE AND CUDA_FOUND)
    add_subdirectory(cuda)
    if(MPI_ENABLE AND MPI_C_FOUND)
      add_subdirectory(mpicuda)
    endif()
  endif()

  if(RAJA_ENABLE AND RAJA_FOUND)
    add_subdirectory(raja)
    if(MPI_ENABLE AND MPI_C_FOUND)
      add_subdirectory(mpiraja)
    endif()
  endif()

endif(EXAMPLES_ENABLE_CUDA)

=== examples/idas/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/idas level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# C examples
IF(EXAMPLES_ENABLE_C)
  ADD_SUBDIRECTORY(serial)
  IF(OPENMP_ENABLE AND OPENMP_FOUND)
    ADD_SUBDIRECTORY(C_openmp)
  ENDIF()
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(parallel)
  ENDIF()
ENDIF()

=== examples/kinsol/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/kinsol level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# C examples
IF(EXAMPLES_ENABLE_C)
  ADD_SUBDIRECTORY(serial)
  IF(OPENMP_ENABLE AND OPENMP_FOUND)
    # the only example here need special handling from testrunner (not yet implemented)
    ADD_SUBDIRECTORY(C_openmp)
  ENDIF()
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(parallel)
  ENDIF()
ENDIF()

# Fortran examples
IF(F77_INTERFACE_ENABLE AND EXAMPLES_ENABLE_F77 AND F77_FOUND)
  ADD_SUBDIRECTORY(fcmix_serial)
  IF(MPI_ENABLE AND MPI_Fortran_FOUND)
    ADD_SUBDIRECTORY(fcmix_parallel)
  ENDIF()
ENDIF()

=== examples/nvector/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner, Slaven Peles, and Cody Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/nvector level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# Always add the nvector serial examples
ADD_SUBDIRECTORY(serial)

IF(MPI_ENABLE AND MPI_C_FOUND)
  ADD_SUBDIRECTORY(parallel)
ENDIF()

IF(HYPRE_ENABLE AND HYPRE_FOUND)
  ADD_SUBDIRECTORY(parhyp)
ENDIF()

IF(PTHREADS_ENABLE AND PTHREADS_FOUND)
  ADD_SUBDIRECTORY(pthreads)
ENDIF()

IF(OPENMP_ENABLE AND OPENMP_FOUND)
  ADD_SUBDIRECTORY(C_openmp)
ENDIF()

IF(OPENMP_DEVICE_ENABLE AND OPENMP_FOUND AND OPENMP_SUPPORTS_DEVICE_OFFLOADING)
  ADD_SUBDIRECTORY(openmpdev)
ENDIF()

IF(PETSC_ENABLE AND PETSC_FOUND)
  ADD_SUBDIRECTORY(petsc)
ENDIF()

IF(CUDA_ENABLE AND CUDA_FOUND)
  ADD_SUBDIRECTORY(cuda)
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(mpicuda)
  ENDIF()
ENDIF()

IF(RAJA_ENABLE AND RAJA_FOUND)
  ADD_SUBDIRECTORY(raja)
  IF(MPI_ENABLE AND MPI_C_FOUND)
    ADD_SUBDIRECTORY(mpiraja)
  ENDIF()
ENDIF()

IF(Trilinos_ENABLE AND Trilinos_FUNCTIONAL)
  ADD_SUBDIRECTORY(trilinos)
ENDIF()

=== examples/sunlinsol/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/sunlinsol level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# Always add the serial sunlinearsolver dense/band/spils examples
ADD_SUBDIRECTORY(band)
ADD_SUBDIRECTORY(dense)

IF(KLU_ENABLE AND KLU_FOUND)
  ADD_SUBDIRECTORY(klu)
ENDIF(KLU_ENABLE AND KLU_FOUND)

IF(SUPERLUMT_ENABLE AND SUPERLUMT_FOUND)
  ADD_SUBDIRECTORY(superlumt)
ENDIF(SUPERLUMT_ENABLE AND SUPERLUMT_FOUND)

IF(LAPACK_ENABLE AND LAPACK_FOUND)
  ADD_SUBDIRECTORY(lapackband)
  ADD_SUBDIRECTORY(lapackdense)
ENDIF(LAPACK_ENABLE AND LAPACK_FOUND)

# Always add serial sunlinearsolver iterative examples
ADD_SUBDIRECTORY(spgmr/serial)
ADD_SUBDIRECTORY(spfgmr/serial)
ADD_SUBDIRECTORY(spbcgs/serial)
ADD_SUBDIRECTORY(sptfqmr/serial)
ADD_SUBDIRECTORY(pcg/serial)

IF(MPI_ENABLE AND MPI_C_FOUND)
  ADD_SUBDIRECTORY(spgmr/parallel)
  ADD_SUBDIRECTORY(spfgmr/parallel)
  ADD_SUBDIRECTORY(spbcgs/parallel)
  ADD_SUBDIRECTORY(sptfqmr/parallel)
  #ADD_SUBDIRECTORY(pcg/parallel)
ENDIF()

=== examples/sunmatrix/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer:  David Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2019, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/sunmatrix level CMakeLists.txt for SUNDIALS (for CMake)
# ---------------------------------------------------------------

# Always add the serial sunmatrix dense/band/sparse examples
ADD_SUBDIRECTORY(dense)
ADD_SUBDIRECTORY(band)
ADD_SUBDIRECTORY(sparse)

=== debian/changelog ===
sundials (4.1.0+dfsg-4) unstable; urgency=medium

  * [5c80d16] Install libsundials_*sunnonlinsol*.so.*. (Closes: #988551)

 -- Anton Gladky <gladk@debian.org>  Sat, 15 May 2021 16:51:20 +0200

sundials (4.1.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Upload into unstable

 -- Anton Gladky <gladk@debian.org>  Sun, 20 Dec 2020 14:20:47 +0100

sundials (4.1.0+dfsg-2) experimental; urgency=medium

  [ Dima Kogan ]
  * Team upload.
  * [dc8951d] Fixed build in gcc-10. Closes: #957847

  [ Anton Gladky ]
  * [97da769] Add .gitlab-ci.yml
  * Upload into unstable

 -- Anton Gladky <gladk@debian.org>  Sat, 19 Dec 2020 19:39:39 +0100

sundials (4.1.0+dfsg-1) experimental; urgency=medium

  * [3f224e1] New upstream version 4.1.0+dfsg
  * [54cabfb] Refresh patches
  * [7119e80] Fix Fortran option
  * [d1a4c40] Fix pthreads not building due to typo
  * [409f1c6] Update symbols/install
  * [cc1da71] Update copyrights for moves
  * [bbe5fbf] Update lintian
  * [5660901] Move to using python 3

 -- James Tocknell <aragilar@gmail.com>  Sat, 19 Oct 2019 21:24:18 +0200

=== debian/control ===
Source: sundials
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>,
           James Tocknell <aragilar@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 11),
               pkg-config,
               chrpath,
               cmake,
               python3,
               gfortran,
               mpi-default-dev,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
               petsc-dev,
               libsuitesparse-dev,
               libhypre-dev (>= 2.15.1-1exp1~)
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/sundials
Vcs-Git: https://salsa.debian.org/science-team/sundials.git
Homepage: http://www.llnl.gov/CASC/sundials/
Rules-Requires-Root: no

Package: libsundials-arkode3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)

Package: libsundials-cvode4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ordinary differential equation solver (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). CVODE is a solver for stiff and nonstiff ODE systems
 (initial value problem) given in explicit form dy/dt = f(t,y).

Package: libsundials-cvodes4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ODE solver with sensistivity analysis (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solver with sensistivity analysis capabilities from SUNDIALS (SUite of
 Nonlinear and DIfferential/ALgebraic equation Solvers). CVODES is a solver for
 stiff and nonstiff ODE systems (initial value problem) given in explicit form
 y' = f(t,y,p) with sensitivity analysis capabilities (both forward and adjoint
 modes).

Package: libsundials-ida4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential-algebraic system solver (SUNDIALS library)
 This package contains the library for differential-algebraic system (IDA)
 solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).

Package: libsundials-idas3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IDA solver with sensitivity capabilities (SUNDIALS library)
 This package contains the library for differential-algebraic system with
 Sensitivity capabilities (IDAS) solver from SUNDIALS (SUite of Nonlinear and
 DIfferential/ALgebraic equation Solvers).

Package: libsundials-kinsol4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: KINSOL solver (SUNDIALS library)
 This package contain the library for KINSOL (nonlinear algebraic systems)
 system solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers).

Package: libsundials-nvecserial4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Non-parallel vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the serial flavor of the library.

Package: libsundials-nvecparallel-mpi4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Description: MPI vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the MPI parallel flavor of the library.

Package: libsundials-nvecparallel-pthread4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Pthread vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the pthread-based parallel flavor of the library.

Package: libsundials-nvecparallel-openmp4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenMP vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the OpenMP-based parallel flavor of the library.

Package: libsundials-nvecparallel-hypre4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HYPRE vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the HYPRE-based parallel flavor of the library.

Package: libsundials-nvecparallel-petsc4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: PETSc vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the PETSc-based parallel flavor of the library.

Package: libsundials-sunlinsol2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-sunmatrix2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-dev
Architecture: any
Section: libdevel
Depends: libsundials-arkode3               (= ${binary:Version}),
         libsundials-cvode4                (= ${binary:Version}),
         libsundials-cvodes4               (= ${binary:Version}),
         libsundials-ida4                  (= ${binary:Version}),
         libsundials-idas3                 (= ${binary:Version}),
         libsundials-kinsol4               (= ${binary:Version}),
         libsundials-nvecserial4           (= ${binary:Version}),
         libsundials-nvecparallel-mpi4     (= ${binary:Version}),
         libsundials-nvecparallel-pthread4 (= ${binary:Version}),
         libsundials-nvecparallel-openmp4  (= ${binary:Version}),
         libsundials-nvecparallel-hypre4   (= ${binary:Version}),
         libsundials-nvecparallel-petsc4   (= ${binary:Version}),
         libsundials-sunlinsol2            (= ${binary:Version}),
         libsundials-sunmatrix2            (= ${binary:Version}),
         cmake, mpi-default-dev, libhypre-dev, petsc-dev, gfortran, pkg-config,
         ${misc:Depends}
Breaks: libsundials-serial-dev
Replaces: libsundials-serial-dev
Description: Package providing everything for SUNDIALS dev work
 This package contains all development files necessary to build applications
 using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). All examples and documentation links live in this package as well.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

include /usr/share/dpkg/architecture.mk

extra_flags += \
	-DCMAKE_Fortran_COMPILER=gfortran \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_STATIC_LIBS:BOOL=ON \
	-DF77_INTERFACE_ENABLE:BOOL=ON \
	-DMPI_ENABLE:BOOL=ON \
	\
	-DSUNDIALS_INDEX_TYPE=int32_t \
	-DLAPACK_ENABLE:BOOL=ON \
	\
	-DEXAMPLES_ENABLE_C:BOOL=ON \
	-DEXAMPLES_ENABLE_CXX:BOOL=ON \
	-DEXAMPLES_ENABLE_F77:BOOL=ON \
	-DEXAMPLES_INSTALL:BOOL=ON \
	\
	-DOPENMP_ENABLE:BOOL=ON \
	-DPTHREAD_ENABLE:BOOL=ON \
	\
	-DKLU_ENABLE:BOOL=ON \
	-DKLU_INCLUDE_DIR=/usr/include/suitesparse \
	-DKLU_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	\
	-DPETSC_ENABLE:BOOL=ON \
	\
	-DHYPRE_ENABLE:BOOL=ON \
	-DHYPRE_INCLUDE_DIR=/usr/include/hypre \
	-DHYPRE_LIBRARY=-lHYPRE_core \
	\
	-DCMAKE_C_FLAGS=-fcommon



# Debian doesn't ship superlu-mt currently, so I turn off this support
extra_flags += -DSUPERLUMT_ENABLE:BOOL=OFF


BUILDDIR = $(CURDIR)/debian/build


%:
	dh $@ --buildsystem=cmake  --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

# Hack from https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
# The OpenMPI variable prevents FTBFS when there are not enough CPUs (see #910352 and #849974)
override_dh_auto_test:
	$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),true,(cd debian/build; OMPI_MCA_rmaps_base_oversubscribe=1 ../nofakeroot ctest))

override_dh_auto_install:
	dh_auto_install
# I strip out all the RPATH/RUNPATH tags from my shared objects. These all point
# to libraries that actually live in standard locations, so the tags are not
# needed
	find debian/tmp/ -name '*.so' -o -name '*.so.*' -exec chrpath -d '{}' \;

# Strip extra license file
	rm debian/tmp/usr/include/sundials/LICENSE

# We copy READMEs by hand because they need to be renamed
override_dh_installdocs:
	dh_installdocs
	mkdir -p debian/libsundials-dev/usr/share/doc/libsundials-dev
	for module in arkode cvode cvodes ida idas kinsol; do \
		cp src/$${module}/README debian/libsundials-dev/usr/share/doc/libsundials-dev/README.$${module}; \
	done

override_dh_compress:
	dh_compress -Xexamples/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)
